%define _topdir /data/buildbot/slave/Source__stable_/build/RPM
%define _rpmdir /data/buildbot/slave/Source__stable_/build/RPM

# Require for libbfd (backtrace support)
BuildRequires: binutils-devel
BuildRoot: /data/buildbot/slave/Source__stable_/build/RPM/BUILDROOT

Name: tarantool
Version: 1.5.3
Release: 120
Group: Applications/Databases
Summary: Tarantool - an efficient in-memory data store
Vendor: tarantool.org
License: BSD
Requires: libgcc >= 4.1.2-50 tarantool-debug = 1.5.3-120
URL: http://tarantool.org
Source0: tarantool-1.5.3-120-ge653835-src.tar.gz
%description
Tarantool is a high performance in-memory NoSQL database. It supports
replication, online backup, stored procedures in Lua.

This package provides the server daemon and administration
scripts.

# Tarantool sql module

%package sql-module
Summary: Tarantool common sql interface
Vendor: tarantool.org
Group: Applications/Databases
Provides: tarantool-sql-module
Obsoletes: tarantool-sql-module
%description -n tarantool-sql-module
Tarantool is a high performance in-memory NoSQL database.
It supports replication, online backup, stored procedures in Lua.

This package provides a common sql interface to use with
tarantool-pg-module or by tarantool-mysql-module.

%package pg-module
Summary: Tarantool common sql interface
Vendor: tarantool.org
Group: Applications/Databases
Provides: tarantool-pg-module
Obsoletes: tarantool-pg-module
%description -n tarantool-pg-module
Tarantool is a high performance in-memory NoSQL database.
It supports replication, online backup, stored procedures in Lua.

This package provides a PostgreSQL interface to use with
tarantool-sql-module.

%package mysql-module
Summary: Tarantool common sql interface
Vendor: tarantool.org
Group: Applications/Databases
Provides: tarantool-mysql-module
Obsoletes: tarantool-mysql-module
%description -n tarantool-mysql-module
Tarantool is a high performance in-memory NoSQL database.
It supports replication, online backup, stored procedures in Lua.

This package provides a MySQL interface to use with
tarantool-sql-module.

# Tarantool sophia module

%package sophia-module
Summary: Tarantool sophia bindings
Vendor: tarantool.org
Group: Applications/Databases
Provides: tarantool-sophia-module
Obsoletes: tarantool-sophia-module
%description -n tarantool-sophia-module
Tarantool is a high performance in-memory NoSQL database.
It supports replication, online backup, stored procedures in Lua.

This package provides tarantool lua bindings to the
sophia database.

# Tarantool client spec

%package client
Summary: Tarantool command line client with history support
Vendor: tarantool.org
Group: Applications/Databases
Provides: tarantool-client
Obsoletes: tarantool-client
%description -n tarantool-client
Tarantool is a high performance in-memory NoSQL database.
It supports replication, online backup, stored procedures in Lua.

This package provides a command line client for Tarantool
with history support.

# Tarantool dev spec

%package dev
Summary: Tarantool C connector and header files
Vendor: tarantool.org
Group: Applications/Databases
#Requires: /sbin/ldconfig
#Requires: tarantool-debug = 1.5.3-120
Provides: tarantool-dev
Obsoletes: tarantool-dev
%description -n tarantool-dev
Tarantool is a high performance in-memory NoSQL database.
It supports replication, online backup, stored procedures in Lua.

This package provides Tarantool client libraries.

# Tarantool debug package

%if 0%{?fedora}
# Fedora includes debug package by default.
%else
%debug_package
%endif

###

%prep
%setup -n tarantool-1.5.3-120-ge653835-src

%build
# https://fedoraproject.org/wiki/Packaging:RPMMacros
cmake . -DCMAKE_BUILD_TYPE=RelWithDebugInfo -DENABLE_CLIENT=ON -DENABLE_RPM=ON \
    -DENABLE_BACKTRACE=ON -DCMAKE_INSTALL_PREFIX=%{_prefix} \
    -DCMAKE_INSTALL_SYSCONFDIR=%{_sysconfdir} \
    -DCMAKE_INSTALL_BINDIR=%{_bindir} \
    -DCMAKE_INSTALL_LIBDIR=%{_libdir}   \
    -DCMAKE_INSTALL_LIBEXECDIR=%{_libexecdir} \
    -DCMAKE_INSTALL_SBINDIR=%{_sbindir} \
    -DCMAKE_INSTALL_SHAREDSTATEDIR=%{_sharedstatedir} \
    -DCMAKE_INSTALL_DATADIR=%{_datadir} \
    -DCMAKE_INSTALL_INCLUDEDIR=%{_includedir} \
    -DCMAKE_INSTALL_INFODIR=%{_infodir} \
    -DCMAKE_INSTALL_MANDIR=%{_mandir} \
    -DCMAKE_INSTALL_LOCALSTATEDIR=%{_localstatedir}

make %{?_smp_mflags}

%install
make DESTDIR=%{buildroot} install

%post
groupadd tarantool > /dev/null 2>&1
useradd -r -g tarantool tarantool > /dev/null 2>&1
# Performe a single instance setup
/usr/bin/tarantool_deploy.sh --yes --quiet 1.1

%preun

%files
%defattr(-,root,root,-)

%dir "%{_datadir}/tarantool"
"%{_datadir}/tarantool/00000000000000000001.snap"

%dir "%{_datadir}/doc/tarantool"
"%{_datadir}/doc/tarantool/README.md"
"%{_datadir}/doc/tarantool/LICENSE"
"%{_datadir}/doc/tarantool/box-protocol.txt"
"%{_mandir}/man1/tarantool_box.1.gz"

"%{_bindir}/tarantool_box"
"%{_bindir}/tarantool_multi.sh"
"%{_bindir}/tarantool_deploy.sh"
"/etc/init.d/tarantool_box"

%dir "%{_sysconfdir}/tarantool"
%config(noreplace) "%{_sysconfdir}/tarantool/tarantool.cfg"

%files sql-module
%defattr(-,root,root,-)
%dir "%{_datadir}/tarantool"
%dir "%{_datadir}/tarantool/box"
%dir "%{_datadir}/tarantool/box/net"
"%{_datadir}/tarantool/box/net/sql.lua"

%files pg-module
%defattr(-,root,root,-)
%dir "%{_libdir}/tarantool/"
%dir "%{_libdir}/tarantool/box"
"%{_libdir}/tarantool/box/net/pg.so"

%files mysql-module
%defattr(-,root,root,-)
%dir "%{_libdir}/tarantool"
%dir "%{_libdir}/tarantool/box"
"%{_libdir}/tarantool/box/net/mysql.so"

%files sophia-module
%defattr(-,root,root,-)
%dir "%{_libdir}/tarantool"
%dir "%{_libdir}/tarantool/box"
"%{_libdir}/tarantool/box/sophia.so"

%files dev
%defattr(-,root,root,-)
%dir "%{_includedir}/tarantool"
"%{_includedir}/tarantool/tnt.h"
"%{_includedir}/tarantool/tnt_buf.h"
"%{_includedir}/tarantool/tnt_call.h"
"%{_includedir}/tarantool/tnt_delete.h"
"%{_includedir}/tarantool/tnt_dir.h"
"%{_includedir}/tarantool/tnt_enc.h"
"%{_includedir}/tarantool/tnt_insert.h"
"%{_includedir}/tarantool/tnt_io.h"
"%{_includedir}/tarantool/tnt_iob.h"
"%{_includedir}/tarantool/tnt_iter.h"
"%{_includedir}/tarantool/tnt_lex.h"
"%{_includedir}/tarantool/tnt_log.h"
"%{_includedir}/tarantool/tnt_mem.h"
"%{_includedir}/tarantool/tnt_net.h"
"%{_includedir}/tarantool/tnt_opt.h"
"%{_includedir}/tarantool/tnt_ping.h"
"%{_includedir}/tarantool/tnt_proto.h"
"%{_includedir}/tarantool/tnt_queue.h"
"%{_includedir}/tarantool/tnt_reply.h"
"%{_includedir}/tarantool/tnt_request.h"
"%{_includedir}/tarantool/tnt_rpl.h"
"%{_includedir}/tarantool/tnt_select.h"
"%{_includedir}/tarantool/tnt_snapshot.h"
"%{_includedir}/tarantool/tnt_sql.h"
"%{_includedir}/tarantool/tnt_stream.h"
"%{_includedir}/tarantool/tnt_tuple.h"
"%{_includedir}/tarantool/tnt_update.h"
"%{_includedir}/tarantool/tnt_utf8.h"
"%{_includedir}/tarantool/tnt_xlog.h"
"%{_libdir}/libtarantool.a"
"%{_libdir}/libtarantool.so"
"%{_libdir}/libtarantool.so.1"
"%{_libdir}/libtarantool.so.1.1"
"%{_libdir}/libtarantoolnet.a"
"%{_libdir}/libtarantoolnet.so"
"%{_libdir}/libtarantoolnet.so.1"
"%{_libdir}/libtarantoolnet.so.1.1"
"%{_libdir}/libtarantoolrpl.a"
"%{_libdir}/libtarantoolrpl.so"
"%{_libdir}/libtarantoolrpl.so.1"
"%{_libdir}/libtarantoolrpl.so.1.1"
"%{_libdir}/libtarantoolsql.a"
"%{_libdir}/libtarantoolsql.so"
"%{_libdir}/libtarantoolsql.so.1"
"%{_libdir}/libtarantoolsql.so.1.1"
%dir "%{_includedir}/tarantool"
"%{_includedir}/tarantool/config.h"
"%{_includedir}/tarantool/lauxlib.h"
"%{_includedir}/tarantool/luaconf.h"
"%{_includedir}/tarantool/lua.h"
"%{_includedir}/tarantool/lua.hpp"
"%{_includedir}/tarantool/luajit.h"
"%{_includedir}/tarantool/lualib.h"

%files client
%defattr(-,root,root,-)
"%{_mandir}/man1/tarantool.1.gz"
"%{_bindir}/tarantool"
"%{_bindir}/tarancheck"
"%{_bindir}/tarantar"

%changelog
* Mon May 20 2013 Dmitry Simonenko <support@tarantool.org> 1.0-1
- Initial version of the RPM spec
